/*
	
	CIDView.cpp v0.8.1
	
	Copyright 1997 Jeremy Rand

This file contains the code for constructing the view which holds the
caller's info.

*/

#include "CIDView.h"

CIDView::CIDView(BRect rect, char *calltime, char *callname,
	char *callnum) : BView(rect, "CIDView", B_FOLLOW_ALL, B_WILL_DRAW)
{
	// The constructor just stores the info from the call
	
	this->SetViewColor(230,230,230);
	
	time_line=new char[strlen(calltime)];
	strcpy(time_line, calltime);
	
	name_line=new char[strlen(callname)];
	strcpy(name_line, callname);
	
	num_line=new char[strlen(callnum)];
	strcpy(num_line, callnum);
	}


CIDView::~CIDView()
{
	// Just free the data we have when the view is destroyed.
	
	delete[] name_line;
	delete[] time_line;
	delete[] num_line;
	}
	
void CIDView::AttachedToWindow()
{
	// This function just calculates the size necessary to hold the data
	// in the view.  Then, it resizes itself to match.
	
	BFont currfont;
	font_height myFontHeight;
	float maxwidth, currwidth;

	GetFont(&currfont);
	currfont.GetHeight(&myFontHeight);
	fontheight = myFontHeight.ascent + myFontHeight.descent + myFontHeight.leading;

	// Got the font height, now calculate the width of the longest line
	// we've got

	maxwidth=StringWidth(time_line);
	currwidth=StringWidth(name_line);
	if (currwidth > maxwidth)
		maxwidth=currwidth;
	currwidth=StringWidth(num_line);
	if (currwidth > maxwidth)
		maxwidth=currwidth;	

	ResizeTo(maxwidth + 20.0 , (fontheight * 3.0) + 7.0 );
	}


void CIDView::Draw(BRect)
{
	// This just draws the view.  It just consists of three lines of data.
	
	MovePenTo(BPoint(10.0, fontheight));
	DrawString(time_line);
	MovePenTo(BPoint(10.0, fontheight * 2.0));
	DrawString(name_line);
	MovePenTo(BPoint(10.0, fontheight * 3.0));
	DrawString(num_line);
	}