/*
	
	CNDWindow.cpp v0.8.1
	
	Copyright 1997 Jeremy Rand

This file contains the code for constructing the windows which hold the
caller's info.

*/

#include "CIDWindow.h"


int CIDWindow::numwin=0;	// Initially, there are no windows


CIDWindow::CIDWindow(BRect frame, char *calltime, char *callname, char *callnum)
	: BWindow(frame, "CallerID", B_TITLED_WINDOW, B_NOT_RESIZABLE)
{
	numwin++;				// Now there is one more window
	frame.OffsetTo(B_ORIGIN);
	myView = new CIDView(frame, calltime, callname, callnum);
	this->AddChild(myView);	// construct and add the CIDView
	}


bool CIDWindow::QuitRequested(void)
{
	numwin--;				// Now there is one less window
	if (!numwin)			// If this is the last one, quit the app
		be_app->PostMessage(B_QUIT_REQUESTED);
	myView->RemoveSelf();
	delete myView;			// Cleanup my view
	return(inherited::QuitRequested());
	}
	

void CIDWindow::AddChild(BView *aView)
{
	// This function just resizes the window to the right size to hold
	// the view.
	
	BRect aRect;
	
	inherited::AddChild(aView);
	this->Lock();
	aRect=aView->Frame();
	this->Unlock();
	ResizeTo(aRect.right, aRect.bottom);
	}