/*
	
	CallDisplay.cpp v0.8.1
	
	Copyright 1997 Jeremy Rand

This file contains the code which sets up the global
environment for the application.  It creates the
BApplication object, sets up the main menu, handles
displaying the settings and about windows, and
cleans up on quit.
	
*/

#include "CallDisplay.h"
#include "CIDWindow.h"

main()
{

	// Pretty standard main() for a BeOS app
	
	CallDisplayApp *myApplication;
	
	myApplication = new CallDisplayApp();
	myApplication->Run();
	
	delete(myApplication);
	return(0);
	}

CallDisplayApp::CallDisplayApp()
		  		  : BApplication(CallDisplayType)
{
	// Set the initial position for the CallDisplay windows
	
	xpos=80;
	ypos=30;
	}


/* void CallDisplayApp::ReadyToRun(void)
{
	// BPopUpMenu *aMenu;
	
	// aMenu=new BPopUpMenu("", FALSE, FALSE);
	// aMenu->AddItem(new BMenuItem("About CallerID...", new BMessage(B_ABOUT_REQUESTED)));
	// aMenu->AddItem(new BMenuItem("Settings...", new BMessage(MSG_SET_WINDOW)));
	// aMenu->AddItem(new BMenuItem("Quit CallerID", new BMessage(B_QUIT_REQUESTED), 'Q'));
	// aMenu->SetTargetForItems(be_app);
	// SetMainMenu(aMenu);					// The above sets up the main menu for the app
	} */

	
void CallDisplayApp::MessageReceived(BMessage *msg)
{
	BRect aRect;
	CIDWindow *aWindow;
	team_id aTeam;
	BMessenger *aMessenger;
	status_t result;
	
	switch (msg->what) {
		case MSG_SET_WINDOW:					// Handle the "Settings..." menu item	
			if ((aTeam=be_roster->TeamFor(CallerIDPrefType)) == B_ERROR) {
						// Launch CallerIDPref if it isn't running
				if (be_roster->Launch(CallerIDPrefType) != B_NO_ERROR) {
					BAlert *anAlert = new BAlert("",
						"Cannot find CallerIDPref executable!",
						"OK");
					anAlert->Go();		// Put up an alert if can't start CallerIDPref
					}
				break;
				}
	
			aMessenger = new BMessenger(CallerIDPrefType, aTeam, &result);	// Set up a messenger to CallerIDPref
			if (result != B_NO_ERROR) {
				BAlert *anAlert = new BAlert("",
					"Cannot connect with running CallerIDPref!", "OK");
				anAlert->Go();			// Failed to make the messenger, alert the user
				}
			else {						// Send the activate message to CallerIDPref
				if (aMessenger->SendMessage(B_WINDOW_ACTIVATED) != B_NO_ERROR) {
					BAlert *anAlert = new BAlert("",
						"Cannot send message to CallDisplay!", "OK");
					anAlert->Go();		// Failed in the send, another alert
					}
				}
			delete aMessenger;
			break;
		
		case MSG_NEW_CALL:
		
			aRect.Set(xpos+20,ypos+40,xpos+150,ypos+80);	// Create the Window's rectangle
		
			xpos+=10;			// Reposition the next window so they aren't right on top
			xpos%=620;			// of each other
			ypos+=10;
			ypos%=400;

			aWindow = new CIDWindow(aRect, (char *)msg->FindString("Time"),
				(char *)msg->FindString("Name"), (char *)msg->FindString("Number"));
			
			aWindow->Show();	// Make the window and show it
			break;
				
		default:								// Handle all other BMessages as usual
			inherited::MessageReceived(msg);
		}
	}


void CallDisplayApp::AboutRequested(void)
{
	// This just displays my meager about window
	
	BAlert *anAlert = new BAlert("",
		"CallDisplay v0.8 by Jeremy Rand\n"
		"jrand@newbridge.com\n"
		"Copyright 1997",
		"Cool");
	
	anAlert->Go();
	}