/*
	
	PrefWindow.cpp v0.8.1
	
	Copyright 1997 Jeremy Rand

This file contains the code for constructing and handling the settings window
There is lots of room for improvement in here probably.

*/

#include "PrefWindow.h"
#include "../CallerIDCommon.h"


PrefWindow::PrefWindow(char *aTitle)
		  : BWindow(BRect(150.0,90.0,440.0,250.0), aTitle,B_TITLED_WINDOW,B_NOT_RESIZABLE)
{
	// The constructor is most concerned with building the user interface for the
	// window.  It is also concerned with setting the default values correctly for
	// the different options (make the StartMessage).
	
	BPopUpMenu *aPopUp;
	BRect aRect;
	BMenuField *aMenuField;
	BMessage *aMessage;
	BView *aView;
	BButton *aButton;
	FILE *fp;
	char buffer[256];
	long aLong;
	team_id theTeam;
	BMessenger *aMessenger;
	status_t result;
	
	// The following deals with selecting the serial port to monitor.  It sets the
	// default to serial2 and builds the popup.  Problems:
	//   1. It is long and repetative
	//   2. It assumes a bebox configuration with 4 serial ports.  BeOS has nothing
	//        I know of to get this info otherwise
	//   3. Can I count on the hard coded rectangle to work into the future?
	
	aView=new BView(BRect(0,0,290,160), "", B_FOLLOW_LEFT_RIGHT|B_FOLLOW_TOP_BOTTOM, B_WILL_DRAW);
	aView->SetViewColor(230,230,230);
	this->AddChild(aView);
	
	if ((fp=fopen("/boot/system/settings/CallerID", "r")) == NULL) {
		fp=fopen("/boot/system/settings/CallerID", "w");
		fprintf(fp, "serial2\n%ld\n%ld\n%ld\n%ld\n\\rATZ\\r\n", B_57600_BPS, B_DATA_BITS_8,
			B_STOP_BITS_1, B_NO_PARITY);
		fclose(fp);
		fp=fopen("/boot/system/settings/CallerID", "r");
		}
	
	StartMessage = new BMessage(MSG_STARTTHREAD);
		
	fgets(buffer, 255, fp);
	buffer[strlen(buffer)-1]=0;
	StartMessage->AddString("serialport", buffer);

	aPopUp=new BPopUpMenu(buffer);

	aMessage=new BMessage(MSG_POP_UP);
	aMessage->AddString("serialport", "serial1");
	aPopUp->AddItem(new BMenuItem("serial1", aMessage));

	aMessage=new BMessage(MSG_POP_UP);
	aMessage->AddString("serialport", "serial2");
	aPopUp->AddItem(new BMenuItem("serial2", aMessage));

	aMessage=new BMessage(MSG_POP_UP);
	aMessage->AddString("serialport", "serial3");
	aPopUp->AddItem(new BMenuItem("serial3", aMessage));

	aMessage=new BMessage(MSG_POP_UP);
	aMessage->AddString("serialport", "serial4");
	aPopUp->AddItem(new BMenuItem("serial4", aMessage));

	aRect.Set(15,10,160,27);
	aMenuField=new BMenuField(aRect,"serialport", "Serial Port:", aPopUp);
	aView->AddChild(aMenuField);
	
	// Now code for doing the same for the baud rate.  Same problems apply.
	
	fgets(buffer, 255, fp);
	aLong=strtol(buffer,NULL,10);
	StartMessage->AddInt32("portspeed", aLong);
    
    switch (aLong) {
    	case B_2400_BPS:
    		aPopUp=new BPopUpMenu("2400");
    		break;
    	case B_4800_BPS:
    		aPopUp=new BPopUpMenu("4800");
    		break;
		case B_9600_BPS:
    		aPopUp=new BPopUpMenu("9600");
    		break;
		case B_19200_BPS:
    		aPopUp=new BPopUpMenu("19200");
    		break;
		case B_38400_BPS:
    		aPopUp=new BPopUpMenu("38400");
    		break;
		case B_57600_BPS:
    		aPopUp=new BPopUpMenu("57600");
    		break;
		case B_115200_BPS:
    		aPopUp=new BPopUpMenu("115200");
    		break;
		default:
    		aPopUp=new BPopUpMenu("57600");
    		StartMessage->ReplaceInt32("portspeed", B_57600_BPS);
    		break;
		}		
	
	aMessage=new BMessage(MSG_POP_UP);
	aMessage->AddInt32("portspeed", B_2400_BPS);
	aPopUp->AddItem(new BMenuItem("2400", aMessage));
	
	aMessage=new BMessage(MSG_POP_UP);
	aMessage->AddInt32("portspeed", B_4800_BPS);
	aPopUp->AddItem(new BMenuItem("4800", aMessage));
	
	aMessage=new BMessage(MSG_POP_UP);
	aMessage->AddInt32("portspeed", B_9600_BPS);
	aPopUp->AddItem(new BMenuItem("9600", aMessage));
	
	aMessage=new BMessage(MSG_POP_UP);
	aMessage->AddInt32("portspeed", B_19200_BPS);
	aPopUp->AddItem(new BMenuItem("19200", aMessage));
	
	aMessage=new BMessage(MSG_POP_UP);
	aMessage->AddInt32("portspeed", B_38400_BPS);
	aPopUp->AddItem(new BMenuItem("38400", aMessage));
	
	aMessage=new BMessage(MSG_POP_UP);
	aMessage->AddInt32("portspeed", B_57600_BPS);
	aPopUp->AddItem(new BMenuItem("57600", aMessage));
	
	aMessage=new BMessage(MSG_POP_UP);
	aMessage->AddInt32("portspeed", B_115200_BPS);
	aPopUp->AddItem(new BMenuItem("115200", aMessage));
	
	aRect.Set(15,35,160,52);
	aMenuField=new BMenuField(aRect,"serialspeed", "Bit Rate:", aPopUp);
	aView->AddChild(aMenuField);
	
	// And now the databits.  Not as bad as the above two cases (ie are there
	// other possible settings for databits?)
	
	fgets(buffer, 255, fp);
    aLong=strtol(buffer,NULL,10);
    StartMessage->AddInt32("databits", aLong);
    
    switch (aLong) {
    	case B_DATA_BITS_8:
    		aPopUp=new BPopUpMenu("8");
    		break;
    	case B_DATA_BITS_7:
    		aPopUp=new BPopUpMenu("7");
    		break;
		default:
    		aPopUp=new BPopUpMenu("8");
    		StartMessage->ReplaceInt32("databits", B_DATA_BITS_8);
    		break;
		}
		
	aMessage=new BMessage(MSG_POP_UP);
	aMessage->AddInt32("databits", B_DATA_BITS_7);
	aPopUp->AddItem(new BMenuItem("7", aMessage));
	
	aMessage=new BMessage(MSG_POP_UP);
	aMessage->AddInt32("databits", B_DATA_BITS_8);
	aPopUp->AddItem(new BMenuItem("8", aMessage));
	
	aRect.Set(15,60,160,77);
	aMenuField=new BMenuField(aRect, "databits", "Data Bits:", aPopUp);
	aView->AddChild(aMenuField);
	
	// And now the stopbits
	
	fgets(buffer, 255, fp);
    aLong=strtol(buffer,NULL,10);
    StartMessage->AddInt32("stopbits", aLong);
    
    switch (aLong) {
    	case B_STOP_BITS_1:
    		aPopUp=new BPopUpMenu("1");
    		break;
    	case B_STOP_BITS_2:
    		aPopUp=new BPopUpMenu("2");
    		break;
		default:
    		aPopUp=new BPopUpMenu("1");
    		StartMessage->ReplaceInt32("stopbits", B_STOP_BITS_1);
    		break;
		}
		
	aMessage=new BMessage(MSG_POP_UP);
	aMessage->AddInt32("stopbits", B_STOP_BITS_1);
	aPopUp->AddItem(new BMenuItem("1", aMessage));
	
	aMessage=new BMessage(MSG_POP_UP);
	aMessage->AddInt32("stopbits", B_STOP_BITS_2);
	aPopUp->AddItem(new BMenuItem("2", aMessage));
	
	aRect.Set(15,85,160,102);
	aMenuField=new BMenuField(aRect, "stopbits", "Stop Bits:", aPopUp);
	aView->AddChild(aMenuField);

	// The last popup is for the parity

	fgets(buffer, 255, fp);
	aLong=strtol(buffer,NULL,10);
	StartMessage->AddInt32("parity", aLong);
	
    switch (aLong) {
    	case B_NO_PARITY:
    		aPopUp=new BPopUpMenu("None");
    		break;
    	case B_EVEN_PARITY:
    		aPopUp=new BPopUpMenu("Even");
    		break;
    	case B_ODD_PARITY:
    		aPopUp=new BPopUpMenu("Odd");
    		break;
		default:
    		aPopUp=new BPopUpMenu("None");
    		StartMessage->ReplaceInt32("parity", B_NO_PARITY);
    		break;
		}
		
	aMessage=new BMessage(MSG_POP_UP);
	aMessage->AddInt32("parity", B_EVEN_PARITY);
	aPopUp->AddItem(new BMenuItem("Even", aMessage));
	
	aMessage=new BMessage(MSG_POP_UP);
	aMessage->AddInt32("parity", B_ODD_PARITY);
	aPopUp->AddItem(new BMenuItem("Odd", aMessage));
	
	aMessage=new BMessage(MSG_POP_UP);
	aMessage->AddInt32("parity", B_NO_PARITY);
	aPopUp->AddItem(new BMenuItem("None", aMessage));
	
	aRect.Set(15,110,160,127);
	aMenuField=new BMenuField(aRect, "parity", "Parity Bits:", aPopUp);
	aView->AddChild(aMenuField);

	// A text control for the initstring

	fgets(buffer, 255, fp);
	buffer[strlen(buffer)-1]=0;
	aRect.Set(15,135,275,152);
	initstring=new BTextControl(aRect,"initstring", "Modem Init String:", buffer, NULL);
	aView->AddChild(initstring);
	
	// This button is for starting/restarting the reader thread
	
	aRect.Set(170,20,270,40);
	StartButton=new BButton(aRect, "start", "Start Daemon", new BMessage(MSG_STARTTHREAD));
	StartButton->MakeDefault(TRUE);
	aView->AddChild(StartButton);
	
	// This button is for stopping the reader thread
	
	aRect.Set(170,50,270,70);
	StopButton=new BButton(aRect, "stop", "Stop Daemon", new BMessage(MSG_STOPTHREAD));
	StopButton->SetEnabled(FALSE);
	aView->AddChild(StopButton);
	
	// This button is for quitting the daemon
	
	aRect.Set(170,80,270,100);
	QuitButton=new BButton(aRect, "quit", "Quit Daemon", new BMessage(MSG_QUITTHREAD));
	QuitButton->SetEnabled(FALSE);
	aView->AddChild(QuitButton);
	
	if ((theTeam = be_roster->TeamFor(CallerIDdType)) != B_ERROR) {
		this->Lock();								// The daemon is currently running
		StartButton->SetLabel("Restart Daemon");	// So we have a restart button
		StopButton->SetEnabled(TRUE);				// And we can Stop/Quit
		QuitButton->SetEnabled(TRUE);
		this->Unlock();
		aMessenger = new BMessenger(CallerIDdType, theTeam, &result);
		if (result != B_NO_ERROR) {					// Try to say "Hello" to the daemon
			BAlert *anAlert = new BAlert("", "Cannot make messenger to daemon!", "OK");
			anAlert->Go();							// Put up alerts if something goes wrong
			}
		else {
			aMessage = new BMessage(MSG_HELLO);
			aMessage->AddMessenger("return", this);
			if (aMessenger->SendMessage(aMessage)) {
				BAlert *anAlert = new BAlert("", "Cannot send message to the daemon!", "OK");
				anAlert->Go();
				}
			delete aMessage;
			}
		delete aMessenger;
		}
	}


void PrefWindow::MessageReceived(BMessage *msg)
{
	// If BMessages come in from the popups, store the settings in StartMessage
	// Message.  This will be passed to the daemon.  The other BMessages this handles
	// is from the stop/start/quit buttons.  Plus, there are some handlers which change
	// the state of the buttons when the daemon's state changes.

	long count, i, DataSize;
	ulong type;
	char *name;
	void *theData;
	team_id theTeam;
	BMessenger *aMessenger;
	BMessage *aMessage;
	status_t result;

	switch(msg->what) {
		case MSG_POP_UP:		// Modify the StartMessage message
			for (i=0; msg->GetInfo(B_STRING_TYPE, i, &name, &type, &count) == B_NO_ERROR; i++) {
				msg->FindData(name, type, &theData, &DataSize);
				StartMessage->ReplaceData(name, type, theData, DataSize);
				}
			for (i=0; msg->GetInfo(B_INT32_TYPE, i, &name, &type, &count) == B_NO_ERROR; i++) {
				msg->FindData(name, type, &theData, &DataSize);
				StartMessage->ReplaceData(name, type, theData, DataSize);
				}
			break;
			
		case MSG_STOPTHREAD:
		case MSG_QUITTHREAD:
			type=MSG_STOPTHREAD;
			if (msg->what == MSG_QUITTHREAD) {
				type=B_QUIT_REQUESTED;
				StartButton->SetLabel("Start Daemon");
				StopButton->SetEnabled(FALSE);
				QuitButton->SetEnabled(FALSE);
				}
			aMessage = new BMessage(type);
			aMessage->AddMessenger("return", this);
				
			if ((theTeam = be_roster->TeamFor(CallerIDdType)) == B_ERROR) {
				BAlert *anAlert = new BAlert("", "Cannot stop daemon cause it isn't running!", "OK");
				anAlert->Go();
				break;
				}
			
			aMessenger = new BMessenger(CallerIDdType, theTeam, &result);	// Try to send a message to the daemon
			if (result != B_NO_ERROR) {
				BAlert *anAlert = new BAlert("", "Cannot make messenger to daemon!", "OK");
				anAlert->Go();
				break;
				}
			if (aMessenger->SendMessage(aMessage) != B_NO_ERROR) {
				BAlert *anAlert = new BAlert("", "Cannot send message to dameon!", "OK");
				anAlert->Go();
				}
			
			delete aMessenger;			// Display an alert if anything goes wrong sending the message
			delete aMessage;
			break;
			
		case MSG_STARTTHREAD:
			StartButton->SetLabel("Restart Daemon");
			StopButton->SetEnabled(TRUE);
			QuitButton->SetEnabled(TRUE);
			aMessage = new BMessage(StartMessage);	// Copy the StartMessage message
			aMessage->AddMessenger("return", this);
			
			aMessage->AddString("initstring", initstring->Text());
									// Add in the initstring info
									
			if ((theTeam = be_roster->TeamFor(CallerIDdType)) == B_ERROR) { 
				if (be_roster->Launch(CallerIDdType, aMessage) != B_NO_ERROR) {	// Launch it if necessary
					BAlert *anAlert = new BAlert("", "Cannot start the CallerIDd executable!", "OK");
					anAlert->Go();
					}
				delete aMessage;
				break;
				}
			
			aMessenger = new BMessenger(CallerIDdType, theTeam, &result);		// Send the message to the daemon
			if (result != B_NO_ERROR) {
				BAlert *anAlert = new BAlert("", "Cannot make messenger to daemon!", "OK");
				anAlert->Go();
				break;
				}
			if (aMessenger->SendMessage(aMessage) != B_NO_ERROR) {
				BAlert *anAlert = new BAlert("", "Cannot send message to dameon!", "OK");
				anAlert->Go();
				}
			delete aMessage;
			delete aMessenger;			// Display an alert if anything goes wrong
			break;

		case MSG_ISRUNNING:				// Setup the buttons if the daemon is running OK
			StartButton->SetLabel("Restart Daemon");
			StopButton->SetEnabled(TRUE);
			QuitButton->SetEnabled(TRUE);
			break;
			
		case MSG_ISSTOPPED:				// Setup the buttons if the deamon has stopped
			StartButton->SetLabel("Start Daemon");
			StopButton->SetEnabled(FALSE);
			break;
			
		case MSG_ISQUIT:
			StartButton->SetLabel("Start Daemon");
			StopButton->SetEnabled(FALSE);
			QuitButton->SetEnabled(FALSE);
			break;
			
		default:
			inherited::MessageReceived(msg);
		}
	}


bool PrefWindow::QuitRequested()
{
	// On quit, save the settings from the window and tell the app to quit.
	
	FILE *fp;
	
	fp=fopen("/boot/system/settings/CallerID", "w");
	fprintf(fp, "%s\n%ld\n%ld\n%ld\n%ld\n%s\n", StartMessage->FindString("serialport"),
		StartMessage->FindInt32("portspeed"), StartMessage->FindInt32("databits"), 
		StartMessage->FindInt32("stopbits"), StartMessage->FindInt32("parity"), initstring->Text());
	fclose(fp);
	
	be_app->PostMessage(B_QUIT_REQUESTED);
	
	return(inherited::QuitRequested());
	}